classification
Title: enable extra compilation warnings
Type: enhancement Stage: resolved
Components: Build Versions: Python 3.5
process
Status: closed Resolution: fixed
Dependencies: Superseder:
Assigned To: Nosy List: Arfrever, ezio.melotti, ned.deily, neologix, pitrou, python-dev, vstinner
Priority: normal Keywords: patch

Created on 2014-07-30 21:51 by neologix, last changed 2016-03-08 06:05 by ned.deily. This issue is now closed.

Files
File name Uploaded Description Edit
extra_warnings.diff neologix, 2014-07-30 21:51 review
Messages (10)
msg224349 - (view) Author: Charles-François Natali (neologix) * (Python committer) Date: 2014-07-30 21:51
The patch attached enables -Wsign-compare and -Wunreachable-code if supported by the compiler.
AFAICT, mixed sign comparison warning is automatically enabled by Microsoft's compiler, and is usually a good thing.
It does add some warnings though.

As for unreachable code, it's also usually a good thing, since it can be a source of bugs. Note that it's not enabled in debug mode, since in debug mode the code paths aren't the same.
msg224354 - (view) Author: Antoine Pitrou (pitrou) * (Python committer) Date: 2014-07-30 22:18
+1 from me.
msg224359 - (view) Author: STINNER Victor (vstinner) * (Python committer) Date: 2014-07-30 22:36
The patch adds a a lot of new warnings. Would it be possible to fix them before applying the patch?
msg224366 - (view) Author: Antoine Pitrou (pitrou) * (Python committer) Date: 2014-07-31 00:14
Enabling the warnings may be a good incitation for other people to fix them ;)
msg224431 - (view) Author: Charles-François Natali (neologix) * (Python committer) Date: 2014-07-31 17:51
> Antoine Pitrou added the comment:
>
> Enabling the warnings may be a good incitation for other people to fix them ;)

That was my intention...

Can I push it, and let warnings be fixed on a case-by-case basis?
msg224445 - (view) Author: Antoine Pitrou (pitrou) * (Python committer) Date: 2014-07-31 20:11
Le 31/07/2014 13:51, Charles-François Natali a écrit :
>
>>
>> Enabling the warnings may be a good incitation for other people to fix them ;)
>
> That was my intention...
>
> Can I push it, and let warnings be fixed on a case-by-case basis?

+1 from me.
msg224519 - (view) Author: Roundup Robot (python-dev) (Python triager) Date: 2014-08-01 20:58
New changeset 2c70897e5f98 by Charles-François Natali in branch 'default':
Issue #22110: Enable extra compilation warnings.
http://hg.python.org/cpython/rev/2c70897e5f98
msg224523 - (view) Author: Charles-François Natali (neologix) * (Python committer) Date: 2014-08-01 21:37
Committed.
Sorry for the extra ~70 warnings :-)
msg224602 - (view) Author: Arfrever Frehtes Taifersar Arahesis (Arfrever) * (Python triager) Date: 2014-08-03 00:50
GCC >=4.5.0 (released on 2010-04-14) silently accepts and ignores -Wunreachable-code option. I think that build system of Python should not pass unused options to compiler.
msg261326 - (view) Author: Ned Deily (ned.deily) * (Python committer) Date: 2016-03-08 06:05
See Issue #24324 which modifies configure to not use -Wunreachable-code with gcc for the reasons stated there and by Arfrever above.
History
Date User Action Args
2016-03-08 06:05:53ned.deilysetnosy: + ned.deily
messages: + msg261326
2014-08-03 00:50:30Arfreversetnosy: + Arfrever
messages: + msg224602
2014-08-01 21:37:10neologixsetstatus: open -> closed
resolution: fixed
messages: + msg224523

stage: resolved
2014-08-01 20:58:24python-devsetnosy: + python-dev
messages: + msg224519
2014-07-31 20:11:30pitrousetmessages: + msg224445
2014-07-31 17:51:24neologixsetmessages: + msg224431
2014-07-31 00:33:48ezio.melottisetnosy: + ezio.melotti
2014-07-31 00:14:06pitrousetmessages: + msg224366
2014-07-30 22:36:54vstinnersetmessages: + msg224359
2014-07-30 22:18:28pitrousetmessages: + msg224354
2014-07-30 21:51:41neologixcreate